from discord.ext import commands
import discord
import markovify
import random


class Markov(commands.Cog):
    def __init__(self, bot):
        self.bot: commands.Bot = bot

    @commands.command(name="markov")
    async def markov(self, ctx: commands.Context, user: discord.Member):

        # Get messages from passed in user
        authors_mesages = []
        for message in await ctx.history(limit=15000).flatten():
            if message.author.id == user.id and "https" not in message.content:
                authors_mesages.append(message.content)

        # Make the model
        user_model = markovify.Text(". ".join(authors_mesages))
        model_json = user_model.to_json()

        dummy = []
        for i in range(random.randint(3, 9)):
            dummy.append(str(user_model.make_sentence(max_words=25, tries=100)))
        await ctx.send(
            "Heres a markov chain based on %s's shitposts" % user.mention
            + "\n\n"
            + " ".join(dummy)
        )


def setup(bot):
    bot.add_cog(Markov(bot))
